FVarLevel Class Reference

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Types | Public Member Functions | Friends | List of all members
FVarLevel Class Reference

`#include <fvarLevel.h>`

## Classes
struct | CreaseEndPair
struct | ETag
struct | ValueSpan
struct | ValueTag

## Public Types
typedef Vtr::ConstArray< ValueTag > | ConstValueTagArray
typedef Vtr::Array< ValueTag > | ValueTagArray
typedef Vtr::ConstArray< CreaseEndPair > | ConstCreaseEndPairArray
typedef Vtr::Array< CreaseEndPair > | CreaseEndPairArray
typedef LocalIndex | Sibling
typedef ConstLocalIndexArray | ConstSiblingArray
typedef LocalIndexArray | SiblingArray

## Public Member Functions
ValueTag | getFaceCompositeValueTag (ConstIndexArray &faceValues, ConstIndexArray &faceVerts) const
Level::VTag | getFaceCompositeValueAndVTag (ConstIndexArray &faceValues, ConstIndexArray &faceVerts, Level::VTag *fvarVTags) const
Level::ETag | getFaceCompositeCombinedEdgeTag (ConstIndexArray &faceEdges, Level::ETag *fvarETags) const
| FVarLevel (Level const &level)
| ~FVarLevel ()
Level const & | getLevel () const
int | getNumValues () const
int | getNumFaceValuesTotal () const
bool | isLinear () const
bool | hasLinearBoundaries () const
bool | hasSmoothBoundaries () const
Sdc::Options | getOptions () const
ConstIndexArray | getFaceValues (Index fIndex) const
IndexArray | getFaceValues (Index fIndex)
ETag | getEdgeTag (Index eIndex) const
bool | edgeTopologyMatches (Index eIndex) const
int | getNumVertexValues (Index v) const
Index | getVertexValueOffset (Index v, Sibling i=0) const
Index | getVertexValue (Index v, Sibling i=0) const
Index | findVertexValueIndex (Index vertexIndex, Index valueIndex) const
ConstIndexArray | getVertexValues (Index vIndex) const
IndexArray | getVertexValues (Index vIndex)
ConstValueTagArray | getVertexValueTags (Index vIndex) const
ValueTagArray | getVertexValueTags (Index vIndex)
ConstCreaseEndPairArray | getVertexValueCreaseEnds (Index vIndex) const
CreaseEndPairArray | getVertexValueCreaseEnds (Index vIndex)
ConstSiblingArray | getVertexFaceSiblings (Index vIndex) const
SiblingArray | getVertexFaceSiblings (Index vIndex)
ValueTag | getValueTag (Index valueIndex) const
bool | valueTopologyMatches (Index valueIndex) const
void | getEdgeFaceValues (Index eIndex, int fIncToEdge, Index valuesPerVert[2]) const
void | getVertexEdgeValues (Index vIndex, Index valuesPerEdge[]) const
void | getVertexCreaseEndValues (Index vIndex, Sibling sibling, Index endValues[2]) const
void | setOptions (Sdc::Options const &options)
void | resizeVertexValues (int numVertexValues)
void | resizeValues (int numValues)
void | resizeComponents ()
void | completeTopologyFromFaceValues (int regBoundaryValence)
void | initializeFaceValuesFromFaceVertices ()
void | initializeFaceValuesFromVertexFaceSiblings ()
void | gatherValueSpans (Index vIndex, ValueSpan *vValueSpans) const
bool | validate () const
void | print () const
void | buildFaceVertexSiblingsFromVertexFaceSiblings (std::vector< Sibling > &fvSiblings) const

## Friends
class | FVarRefinement

## Detailed Description

Definition at line 78 of file fvarLevel.h.

## Member Typedef Documentation

typedef Vtr::ConstArray<CreaseEndPair> ConstCreaseEndPairArray

Definition at line 150 of file fvarLevel.h.

typedef ConstLocalIndexArray ConstSiblingArray

Definition at line 155 of file fvarLevel.h.

typedef Vtr::ConstArray<ValueTag> ConstValueTagArray

Definition at line 127 of file fvarLevel.h.

typedef Vtr::Array<CreaseEndPair> CreaseEndPairArray

Definition at line 151 of file fvarLevel.h.

typedef LocalIndex Sibling

Definition at line 153 of file fvarLevel.h.

typedef LocalIndexArray SiblingArray

Definition at line 156 of file fvarLevel.h.

typedef Vtr::Array<ValueTag> ValueTagArray

Definition at line 128 of file fvarLevel.h.

## Constructor & Destructor Documentation

FVarLevel | ( | Level const & | level | ) |

~FVarLevel | ( |  | ) |

## Member Function Documentation

void buildFaceVertexSiblingsFromVertexFaceSiblings | ( | std::vector< Sibling > & | fvSiblings | ) | const

void completeTopologyFromFaceValues | ( | int | regBoundaryValence | ) |

bool edgeTopologyMatches | ( | Index | eIndex | ) | const
| inline

Definition at line 180 of file fvarLevel.h.

Index findVertexValueIndex | ( | Index | vertexIndex,
|  | Index | valueIndex
| ) |  | const
| inline

Definition at line 358 of file fvarLevel.h.

void gatherValueSpans | ( | Index | vIndex,
|  | ValueSpan * | vValueSpans
| ) |  | const

void getEdgeFaceValues | ( | Index | eIndex,
|  | int | fIncToEdge,
|  | Index | valuesPerVert[2]
| ) |  | const

ETag getEdgeTag | ( | Index | eIndex | ) | const
| inline

Definition at line 179 of file fvarLevel.h.

Level::ETag getFaceCompositeCombinedEdgeTag | ( | ConstIndexArray & | faceEdges,
|  | Level::ETag * | fvarETags
| ) |  | const

Level::VTag getFaceCompositeValueAndVTag | ( | ConstIndexArray & | faceValues,
|  | ConstIndexArray & | faceVerts,
|  | Level::VTag * | fvarVTags
| ) |  | const

ValueTag getFaceCompositeValueTag | ( | ConstIndexArray & | faceValues,
|  | ConstIndexArray & | faceVerts
| ) |  | const

ConstIndexArray getFaceValues | ( | Index | fIndex | ) | const
| inline

Definition at line 283 of file fvarLevel.h.

IndexArray getFaceValues | ( | Index | fIndex | ) |
| inline

Definition at line 290 of file fvarLevel.h.

Level const& getLevel | ( |  | ) | const
| inline

Definition at line 163 of file fvarLevel.h.

int getNumFaceValuesTotal | ( |  | ) | const
| inline

Definition at line 166 of file fvarLevel.h.

int getNumValues | ( |  | ) | const
| inline

Definition at line 165 of file fvarLevel.h.

int getNumVertexValues | ( | Index | v | ) | const
| inline

Definition at line 183 of file fvarLevel.h.

Sdc::Options getOptions | ( |  | ) | const
| inline

Definition at line 172 of file fvarLevel.h.

ValueTag getValueTag | ( | Index | valueIndex | ) | const
| inline

Definition at line 204 of file fvarLevel.h.

void getVertexCreaseEndValues | ( | Index | vIndex,
|  | Sibling | sibling,
|  | Index | endValues[2]
| ) |  | const

void getVertexEdgeValues | ( | Index | vIndex,
|  | Index | valuesPerEdge[]
| ) |  | const

FVarLevel::ConstSiblingArray getVertexFaceSiblings | ( | Index | vIndex | ) | const
| inline

Definition at line 298 of file fvarLevel.h.

FVarLevel::SiblingArray getVertexFaceSiblings | ( | Index | vIndex | ) |
| inline

Definition at line 305 of file fvarLevel.h.

Index getVertexValue | ( | Index | v,
|  | Sibling | i = `0`
| ) |  | const
| inline

Definition at line 186 of file fvarLevel.h.

FVarLevel::ConstCreaseEndPairArray getVertexValueCreaseEnds | ( | Index | vIndex | ) | const
| inline

Definition at line 343 of file fvarLevel.h.

FVarLevel::CreaseEndPairArray getVertexValueCreaseEnds | ( | Index | vIndex | ) |
| inline

Definition at line 350 of file fvarLevel.h.

Index getVertexValueOffset | ( | Index | v,
|  | Sibling | i = `0`
| ) |  | const
| inline

Definition at line 184 of file fvarLevel.h.

ConstIndexArray getVertexValues | ( | Index | vIndex | ) | const
| inline

Definition at line 313 of file fvarLevel.h.

IndexArray getVertexValues | ( | Index | vIndex | ) |
| inline

Definition at line 320 of file fvarLevel.h.

FVarLevel::ConstValueTagArray getVertexValueTags | ( | Index | vIndex | ) | const
| inline

Definition at line 328 of file fvarLevel.h.

FVarLevel::ValueTagArray getVertexValueTags | ( | Index | vIndex | ) |
| inline

Definition at line 335 of file fvarLevel.h.

bool hasLinearBoundaries | ( |  | ) | const
| inline

Definition at line 169 of file fvarLevel.h.

bool hasSmoothBoundaries | ( |  | ) | const
| inline

Definition at line 170 of file fvarLevel.h.

void initializeFaceValuesFromFaceVertices | ( |  | ) |

void initializeFaceValuesFromVertexFaceSiblings | ( |  | ) |

bool isLinear | ( |  | ) | const
| inline

Definition at line 168 of file fvarLevel.h.

void print | ( |  | ) | const

void resizeComponents | ( |  | ) |

void resizeValues | ( | int | numValues | ) |

void resizeVertexValues | ( | int | numVertexValues | ) |

void setOptions | ( | Sdc::Options const & | options | ) |

bool validate | ( |  | ) | const

bool valueTopologyMatches | ( | Index | valueIndex | ) | const
| inline

Definition at line 205 of file fvarLevel.h.

## Friends And Related Function Documentation

friend class FVarRefinement
| friend

Definition at line 239 of file fvarLevel.h.

The documentation for this class was generated from the following file:

- opensubdiv/vtr/fvarLevel.h